<template>
  <svg class="rui-icon" :class="cssClasses" viewBox="0 0 24 24">
    <title v-if="title">{{ title }}</title>
    <use :xlink:href="`${$_ruiIconsFile}#icon-${name}`" />
  </svg>
</template>

<script>
export const sizes = ['3', '4', '10']

/**
 * Displays icons.
 *
 * The color is the CSS `currentColor` value, and size is in `em`.
 *
 * @preset default { "props": { "name": "home" } }
 */
export default {
  name: 'RuiIcon',
  props: {
    /** Icon name */
    name: { required: true, type: String },
    /**
     * Custom icon size. Will be in `em`
     *
     * @values 3, 4, 10
     */
    size: { required: false, type: [String, Number], default: null, validator: v => sizes.includes(v.toString()) },
    /** Title to show when hovering the icon */
    title: { required: false, type: String, default: null },
    /** Make the icon spin */
    spin: { required: false, type: Boolean, default: false },
  },
  computed: {
    cssClasses () {
      const classes = []
      if (this.spin) classes.push('rui-icon--spin')
      if (this.size) classes.push(`rui-icon--${this.size}x`)

      return classes.join(' ')
    },
  },
}
</script>
